#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2400six4xi.py">
#<abstract4xi abstract = "fires to direction six and to distance 2400"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2six4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2SIX - COORDINATE SIGNS OF SHOOT2SIX4XI: (X - ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2six24004xi




# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2six24004xi = {
                1:'-1028x1099y-1869z',
                2:'-1036x2008y-806z',
                3:'-1068x2007y-767z',
                4:'-1070x1030y-1884z',
                5:'-1109x961y-1899z',
                6:'-1136x1944y-829z',
                7:'-1142x889y-1913z',
                8:'-1168x1941y-790z',
                9:'-1172x817y-1928z',
                10:'-1196x745y-1942z',
                11:'-119x944y-2203z',
                12:'-1208x40y-2073z',
                13:'-1217x672y-1956z',
                14:'-1225x105y-2061z',
                15:'-1231x1875y-851z',
                16:'-1232x599y-1970z',
                17:'-1238x172y-2048z',
                18:'-1244x525y-1983z',
                19:'-1247x240y-2036z',
                20:'-1251x453y-1997z',
                21:'-1253x310y-2023z',
                22:'-1254x381y-2010z',
                23:'-1263x1871y-812z',
                24:'-1323x1801y-874z',
                25:'-1354x1796y-835z',
                26:'-1410x1722y-896z',
                27:'-1441x1716y-857z',
                28:'-1492x1639y-918z',
                29:'-1514x1861y-6z',
                30:'-1523x1632y-880z',
                31:'-1569x1553y-940z',
                32:'-1600x1543y-902z',
                33:'-1609x1779y-30z',
                34:'-1641x1462y-962z',
                35:'-165x915y-2212z',
                36:'-1672x1452y-924z',
                37:'-1700x1692y-54z',
                38:'-1708x1368y-984z',
                39:'-1738x1356y-946z',
                40:'-1769x1271y-1006z',
                41:'-1786x1601y-78z',
                42:'-1799x1258y-968z',
                43:'-1824x1171y-1028z',
                44:'-1854x1157y-990z',
                45:'-1866x1504y-102z',
                46:'-1874x1069y-1049z',
                47:'-1903x1053y-1012z',
                48:'-1918x964y-1071z',
                49:'-1942x1404y-126z',
                50:'-1956x858y-1092z',
                51:'-1988x751y-1114z',
                52:'-2011x1300y-150z',
                53:'-2014x642y-1135z',
                54:'-2028x987y-1077z',
                55:'-2034x533y-1156z',
                56:'-2047x424y-1177z',
                57:'-2052x96y-1239z',
                58:'-2055x314y-1198z',
                59:'-2057x205y-1219z',
                60:'-2075x1192y-174z',
                61:'-207x883y-2221z',
                62:'-212x1705y-1675z',
                63:'-2133x1081y-198z',
                64:'-2185x967y-222z',
                65:'-2230x850y-246z',
                66:'-2269x731y-270z',
                67:'-2302x611y-294z',
                68:'-2327x489y-318z',
                69:'-2347x366y-341z',
                70:'-2359x242y-365z',
                71:'-2365x118y-389z',
                72:'-247x850y-2230z',
                73:'-253x2297y-646z',
                74:'-284x815y-2239z',
                75:'-298x1675y-1692z',
                76:'-318x778y-2247z',
                77:'-329x10y-2377z',
                78:'-348x740y-2256z',
                79:'-352x29y-2373z',
                80:'-372x2274y-669z',
                81:'-374x51y-2370z',
                82:'-376x701y-2264z',
                83:'-381x1640y-1709z',
                84:'-394x74y-2366z',
                85:'-400x661y-2272z',
                86:'-403x2280y-629z',
                87:'-412x101y-2362z',
                88:'-422x620y-2279z',
                89:'-429x129y-2357z',
                90:'-440x579y-2287z',
                91:'-444x159y-2353z',
                92:'-455x537y-2294z',
                93:'-456x191y-2348z',
                94:'-461x1601y-1726z',
                95:'-466x496y-2301z',
                96:'-467x225y-2343z',
                97:'-475x261y-2337z',
                98:'-475x455y-2307z',
                99:'-481x297y-2332z',
                100:'-481x414y-2314z',
                101:'-483x335y-2326z',
                102:'-484x375y-2320z',
                103:'-489x2245y-692z',
                104:'-520x2250y-652z',
                105:'-539x1559y-1743z',
                106:'-604x2209y-715z',
                107:'-613x1512y-1759z',
                108:'-635x2213y-676z',
                109:'-684x1462y-1775z',
                110:'-717x2168y-738z',
                111:'-71x971y-2193z',
                112:'-748x2170y-699z',
                113:'-751x1408y-1791z',
                114:'-815x1351y-1807z',
                115:'-826x2120y-761z',
                116:'-858x2121y-721z',
                117:'-874x1292y-1823z',
                118:'-930x1230y-1838z',
                119:'-933x2067y-784z',
                120:'-965x2067y-744z',
                121:'-981x1165y-1854z'}


#"
#/>



# -------------------------------------------------------------------------------------------------------------------
#<function4xi function = "fire2400six4xi" usage = "target function for charge2six4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------------------------
def fire2400six4xi(queue2six, consumer_channel2six, publisher_channel2six):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2400SIX4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2400SIX4XI -  QUEUE2SIX: ", queue2six)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2400SIX4XI -  CONSUMER_CHANNEL2SIX: ", consumer_channel2six)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2400SIX4XI -  PUBLISHER_CHANNEL2SIX: ", publisher_channel2six)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2400SIX4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2six.put(shot2six24004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2400SIX4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2400SIX4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2400SIX4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2six8shot2six2400x4xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2six8shot2six2400x4xi</nack2put4xi>" 
            
        publisher_channel2six.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2400SIX4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi()) 
            # 
        
    except:
        print(" (STEP 3C/33) OF FIRE2400SIX4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2400SIX4XI - RETURNING QUEUE OBJECT QUEUE2SIX: ", queue2six, " - TIME: ", time4xi())  
        # 
            
    return queue2six    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2400six4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
